--------------------------------------------------------------------------------
local styles = data.raw["gui-style"].default

--------------------------------------------------------------------------------
function load_dialogue_sprite(image_name, image_path, width, height)
  styles[image_name] = {
    type = "button_style",
    width = width,
    height = height,
    priority = "extra-high-no-scale",
    clicked_graphical_set = { filename = image_path, scale = 1, width = width, height = height},
    default_graphical_set = { filename = image_path, scale = 1, width = width, height = height},
    disabled_graphical_set = { filename = image_path, scale = 1, width = width, height = height},
    hovered_graphical_set = { filename = image_path, scale = 1, width = width, height = height},
  }
end
load_dialogue_sprite("Main_page", "__dialogue-box__/graphics/db_mainpage.png", 830, 548)

--------------------------------------------------------------------------------
styles["dialogue_inner_frame"] = {
    type = "frame_style",
    parent = "frame",
    graphical_set = {
    base = {
      center = {
        position = { 42, 8 },
        size = { 1,1 }
      },
      corner_size = 8,
      draw_type = "outer",
      position = {17,0}
      }
    },
    top_padding = 0,
    left_padding = 0,
}

--------------------------------------------------------------------------------
styles["dialogue_image_sprite"] = {
	type = "button_style",
	parent = "button",
	width = 120,
	height = 155,
  padding = 0,
  bottom_padding = 0,
}

--------------------------------------------------------------------------------
styles["dialogue_correction"] = {
  type = "vertical_flow_style",
  top_padding = 0,
  left_padding = -6,
}

--------------------------------------------------------------------------------
styles["dialogue_person_button"] = {
  type = "button_style",
  font = "default-listbox",
  horizontal_align = "left",
  width = 200,
  bottom_margin = -3,
  default_font_color = {0.9,0.9,0.9},
  hovered_font_color = {0.0,0.0,0.0},
  clicked_graphical_set = {
    corner_size = 8,
    position = { 51, 17 }
  },
  default_graphical_set = {
    corner_size = 8,
    position = { 208, 17 }
  },
  disabled_graphical_set = {
    corner_size = 8,
    position = { 17, 17 }
  },
  hovered_graphical_set = {
    base = {
      corner_size = 8,
      position = { 34, 17 }
    }
  }
}
