event_handler={event_listeners={}}

function event_handler.addListener(event_id, to_add, is_special, tag)
  local tag = tag or "ordinary"
  if not event_handler.event_listeners[event_id] then
    event_handler.event_listeners[event_id] = {}
    event_handler.event_listeners[event_id].tag = {}
    event_handler.event_listeners[event_id].callbacks = {}
    event_handler.event_listeners[event_id].sequence = function (event)
      for i, cb in pairs(event_handler.event_listeners[event_id].callbacks) do cb(event) end
    end
    if not is_special then script.on_event(event_id, event_handler.event_listeners[event_id].sequence) end
    table.insert(event_handler.event_listeners[event_id].callbacks, to_add)
    table.insert(event_handler.event_listeners[event_id].tag, tag)
  else
    for i, cb in pairs(event_handler.event_listeners[event_id].callbacks) do
      if cb == to_add then return end
    end
    if not exists then
      table.insert(event_handler.event_listeners[event_id].callbacks, to_add)
      table.insert(event_handler.event_listeners[event_id].tag, tag)
    end
  end
end

function event_handler.trigger_event(event_id, data)
  if event_handler.event_listeners[event_id] then
    event_handler.event_listeners[event_id].sequence(data)
  end
end

function event_handler.removeListener(event_id, to_remove, tag)
  local tag = tag or "false"
  if event_id==nil and to_remove==nil then
    for event_id_n, ev in pairs(event_handler.event_listeners) do
      if ev.tag[1] == tag then
        for i, cb in pairs(ev.callbacks) do
          event_handler.event_listeners[event_id_n].callbacks[i] = nil
        end
      end
    end
  else
    if not event_handler.event_listeners[event_id] then
      return
    end
    for i, cb in pairs(event_handler.event_listeners[event_id].callbacks) do
      if cb == to_remove then
        event_handler.event_listeners[event_id].callbacks[i] = nil
      end
    end
  end
end

script.on_init(function(event)
  event_handler.trigger_event("on_init", event)
end)
script.on_load(function(event)
  event_handler.trigger_event("on_load", event)
end)
script.on_configuration_changed(function(event)
  event_handler.trigger_event("on_configuration_changed", event)
end)

return event_handler
