--------------------------------------------------------------------------------
function db_add_titlebar(gui, caption, close_button_name, is_log)
  is_log = is_log or false
  local titlebar = gui.add{type = "flow"}
  titlebar.drag_target = gui
  local titletext = titlebar.add{
    type = "label",
    style = "frame_title",
    caption = caption,
    ignored_by_interaction = true,
  }
  if is_log then
    titletext.style.width = 200
  end
  local filler = titlebar.add{
    type = "empty-widget",
    style = "draggable_space",
    ignored_by_interaction = true,
  }
  filler.style.height = 23
  filler.style.horizontally_stretchable = true
  titlebar.add{
    type = "sprite-button",
    name = close_button_name,
    style = "frame_action_button",
    sprite = "utility/close_white",
    hovered_sprite = "utility/close_black",
    clicked_sprite = "utility/close_black",
    tooltip = {"gui.close-instruction"},
  }
end

--------------------------------------------------------------------------------
function db_destroy_gui(screen_element)
  for num,elm in pairs(screen_element.children) do
    elm.destroy()
  end
end

--------------------------------------------------------------------------------
