remote.add_interface("dialogue-box", {
  get_dialogues = function(key) return global[key] end,
  set_dialogues = function(key, value) global[key] = value end,
  -- Custom conditions
  always_true = function(event) return true end,
  example_condition = function(event) return event.item_stack.name=="stone-furnace" end,
})

-- NOTE: The order of the dialogues is important, the logs will be displayed with the same order
--       Also order of the people can be modified by moving them up or down

global.dialogues = {

  example_dialogue_1 = {
    person="Uncle",                                                 -- Used in the title of the dialogue and as a "id" for the image to display
    active=true,                                                    -- Set to true to be used as trigger-dialogue, Set to false to be displayed only in the logs (if false trigger and condition has no effect)
    trigger=defines.events.on_cutscene_cancelled,                   -- trigger LuaEvent
    condition="always_true",                                        -- Name of the function defined in the remote interface
    caption="This is a custom dialogue.\nJust want to say hi!"},    -- dialogue caption

  example_log_only = {
    person="Uncle",
    active=false,
    trigger=0,                                                      -- If active is set to false trigger and condition should be defined to 0
    condition=0,
    caption="This is not a dialogue, just an information"},

  example_dialogue_2 = {
    person="Daniel",
    active=true,
    trigger=defines.events.on_player_mined_item,
    condition="example_condition",
    caption="Furnace is hot"},

  example_dialogue_3 = {
    person="Daniel",
    active=true,
    trigger=defines.events.on_console_chat,
    condition="always_true",
    caption="Hey, its the first time you said something in chat. This is a very long sentence that has no meaning at all, anyway its going to be something about a random chat thing"},
}